#include <stdio.h>
#include <stdlib.h>
#include <opencv/highgui.h>
#include <opencv/cv.h>

#define CV_BGR2HSV 40

int main (int argc, char* argv[])
{
  IplImage* imagergb = NULL;

    double tolerance=0;
    printf("entrer la tolerance");
    scanf("%lf", &tolerance);

  /* Vérification: au moins 2 arguments doivent être passés au programme.*/
  if (argc < 3)
  {
    fprintf (stderr, "usage: %s entrer une IMAGE en paramètre \n", argv[0]);
    return EXIT_FAILURE;
  }


  /* Chargement de l'image passée en argument */
  imagergb = cvLoadImage(argv[1], CV_LOAD_IMAGE_UNCHANGED);

  if (!imagergb)
  {
    fprintf (stderr, "couldn't open image file: %s\n", argv[1]);
    return EXIT_FAILURE;
  }

//convertir l'image en hsv
  IplImage *imagehsv;
  imagehsv = cvCloneImage(imagergb);
  cvCvtColor(imagergb, imagehsv, CV_BGR2HSV);

//créer un masque de la même taille que l'image
  IplImage *imagebin;
  imagebin = cvCreateImage(cvGetSize(imagehsv), imagehsv->depth, 1);

    tolerance = 255*tolerance/100;

//binariser l'image hsv
  cvInRangeS(imagehsv,cvScalar(0, 255-tolerance, 255-tolerance,0),cvScalar(0+tolerance, 255, 255,0),imagebin);

//sauvegarder
  cvSaveImage(argv[2], imagebin, 0);


  /* Libération de la mémoire */
  cvReleaseImage (&imagergb);
  cvReleaseImage(&imagehsv);
  cvReleaseImage(&imagebin);

  return EXIT_SUCCESS;
}

