#include <stdio.h>
#include <stdlib.h>
#include <opencv/highgui.h>
#include <opencv/cv.h>

#define CV_BGR2HSV 40

int main (int argc, char* argv[])
{
  IplImage* image = NULL;
  const char* window_title = "Hello, OpenCV!";

  /* Vérification: au moins 2 arguments doivent être passés au programme.*/
  if (argc < 3)
  {
    fprintf (stderr, "usage: %s IMAGE\n", argv[0]);
    return EXIT_FAILURE;
  }

  /* Chargement de l'image passée en argument */
  image = cvLoadImage(argv[1], CV_LOAD_IMAGE_UNCHANGED);

  if (!image)
  {
    fprintf (stderr, "couldn't open image file: %s\n", argv[1]);
    return EXIT_FAILURE;
  }
//convertir l'image en hsv
  IplImage *hsv;
  hsv = cvCloneImage(image);
  cvCvtColor(image, hsv, CV_BGR2HSV);

//créer un masque de la même taille que l'image
  IplImage *mask;
  mask = cvCreateImage(cvGetSize(hsv), hsv->depth, 1);

//binariser l'image hsv
  cvInRangeS(hsv,cvScalar(0, 200, 200,0),cvScalar(0, 255, 255,0),mask);

//sauvegarder
  cvSaveImage(argv[2], hsv, 0);



  /* Libération de la mémoire */
  cvReleaseImage (&image);
  cvReleaseImage(&hsv);
  cvReleaseImage(&mask);

  return EXIT_SUCCESS;
}
